# coding: utf-8

"""
    Algorithmia Management APIs

    APIs for managing actions on the Algorithmia platform  # noqa: E501

    The version of the OpenAPI document: 1.5.0
    Contact: support@algorithmia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from algorithmia_api_client.configuration import Configuration


class ConnectorResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'connector_id': 'str',
        'username': 'str',
        'label': 'str',
        'protocol': 'str',
        'is_default': 'bool',
        'permissions': 'list[str]'
    }

    attribute_map = {
        'connector_id': 'connector_id',
        'username': 'username',
        'label': 'label',
        'protocol': 'protocol',
        'is_default': 'is_default',
        'permissions': 'permissions'
    }

    def __init__(self, connector_id=None, username=None, label=None, protocol=None, is_default=None, permissions=None, local_vars_configuration=None):  # noqa: E501
        """ConnectorResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._connector_id = None
        self._username = None
        self._label = None
        self._protocol = None
        self._is_default = None
        self._permissions = None
        self.discriminator = None

        if connector_id is not None:
            self.connector_id = connector_id
        if username is not None:
            self.username = username
        if label is not None:
            self.label = label
        if protocol is not None:
            self.protocol = protocol
        if is_default is not None:
            self.is_default = is_default
        if permissions is not None:
            self.permissions = permissions

    @property
    def connector_id(self):
        """Gets the connector_id of this ConnectorResponse.  # noqa: E501


        :return: The connector_id of this ConnectorResponse.  # noqa: E501
        :rtype: str
        """
        return self._connector_id

    @connector_id.setter
    def connector_id(self, connector_id):
        """Sets the connector_id of this ConnectorResponse.


        :param connector_id: The connector_id of this ConnectorResponse.  # noqa: E501
        :type: str
        """

        self._connector_id = connector_id

    @property
    def username(self):
        """Gets the username of this ConnectorResponse.  # noqa: E501


        :return: The username of this ConnectorResponse.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this ConnectorResponse.


        :param username: The username of this ConnectorResponse.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def label(self):
        """Gets the label of this ConnectorResponse.  # noqa: E501


        :return: The label of this ConnectorResponse.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this ConnectorResponse.


        :param label: The label of this ConnectorResponse.  # noqa: E501
        :type: str
        """

        self._label = label

    @property
    def protocol(self):
        """Gets the protocol of this ConnectorResponse.  # noqa: E501


        :return: The protocol of this ConnectorResponse.  # noqa: E501
        :rtype: str
        """
        return self._protocol

    @protocol.setter
    def protocol(self, protocol):
        """Sets the protocol of this ConnectorResponse.


        :param protocol: The protocol of this ConnectorResponse.  # noqa: E501
        :type: str
        """
        allowed_values = ["s3", "dropbox", "azureblob", "gs"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and protocol not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `protocol` ({0}), must be one of {1}"  # noqa: E501
                .format(protocol, allowed_values)
            )

        self._protocol = protocol

    @property
    def is_default(self):
        """Gets the is_default of this ConnectorResponse.  # noqa: E501


        :return: The is_default of this ConnectorResponse.  # noqa: E501
        :rtype: bool
        """
        return self._is_default

    @is_default.setter
    def is_default(self, is_default):
        """Sets the is_default of this ConnectorResponse.


        :param is_default: The is_default of this ConnectorResponse.  # noqa: E501
        :type: bool
        """

        self._is_default = is_default

    @property
    def permissions(self):
        """Gets the permissions of this ConnectorResponse.  # noqa: E501


        :return: The permissions of this ConnectorResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this ConnectorResponse.


        :param permissions: The permissions of this ConnectorResponse.  # noqa: E501
        :type: list[str]
        """

        self._permissions = permissions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConnectorResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ConnectorResponse):
            return True

        return self.to_dict() != other.to_dict()
