# coding: utf-8

"""
    Algorithmia Management APIs

    APIs for managing actions on the Algorithmia platform  # noqa: E501

    The version of the OpenAPI document: 1.5.0
    Contact: support@algorithmia.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from algorithmia_api_client.configuration import Configuration


class EventListener(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'source_type': 'EventListenerSourceType',
        'source_uri': 'str',
        'algo_name': 'str',
        'algo_owner': 'str',
        'algo_version': 'str',
        'algo_timeout_seconds': 'int',
        'listener_owner': 'str',
        'credentials': 'str'
    }

    attribute_map = {
        'id': 'id',
        'source_type': 'sourceType',
        'source_uri': 'sourceURI',
        'algo_name': 'algoName',
        'algo_owner': 'algoOwner',
        'algo_version': 'algoVersion',
        'algo_timeout_seconds': 'algoTimeoutSeconds',
        'listener_owner': 'listenerOwner',
        'credentials': 'credentials'
    }

    def __init__(self, id=None, source_type=None, source_uri=None, algo_name=None, algo_owner=None, algo_version=None, algo_timeout_seconds=420, listener_owner=None, credentials=None, local_vars_configuration=None):  # noqa: E501
        """EventListener - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._source_type = None
        self._source_uri = None
        self._algo_name = None
        self._algo_owner = None
        self._algo_version = None
        self._algo_timeout_seconds = None
        self._listener_owner = None
        self._credentials = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.source_type = source_type
        self.source_uri = source_uri
        self.algo_name = algo_name
        self.algo_owner = algo_owner
        self.algo_version = algo_version
        if algo_timeout_seconds is not None:
            self.algo_timeout_seconds = algo_timeout_seconds
        if listener_owner is not None:
            self.listener_owner = listener_owner
        self.credentials = credentials

    @property
    def id(self):
        """Gets the id of this EventListener.  # noqa: E501


        :return: The id of this EventListener.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this EventListener.


        :param id: The id of this EventListener.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def source_type(self):
        """Gets the source_type of this EventListener.  # noqa: E501


        :return: The source_type of this EventListener.  # noqa: E501
        :rtype: EventListenerSourceType
        """
        return self._source_type

    @source_type.setter
    def source_type(self, source_type):
        """Sets the source_type of this EventListener.


        :param source_type: The source_type of this EventListener.  # noqa: E501
        :type: EventListenerSourceType
        """
        if self.local_vars_configuration.client_side_validation and source_type is None:  # noqa: E501
            raise ValueError("Invalid value for `source_type`, must not be `None`")  # noqa: E501

        self._source_type = source_type

    @property
    def source_uri(self):
        """Gets the source_uri of this EventListener.  # noqa: E501


        :return: The source_uri of this EventListener.  # noqa: E501
        :rtype: str
        """
        return self._source_uri

    @source_uri.setter
    def source_uri(self, source_uri):
        """Sets the source_uri of this EventListener.


        :param source_uri: The source_uri of this EventListener.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and source_uri is None:  # noqa: E501
            raise ValueError("Invalid value for `source_uri`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                source_uri is not None and len(source_uri) > 255):
            raise ValueError("Invalid value for `source_uri`, length must be less than or equal to `255`")  # noqa: E501

        self._source_uri = source_uri

    @property
    def algo_name(self):
        """Gets the algo_name of this EventListener.  # noqa: E501


        :return: The algo_name of this EventListener.  # noqa: E501
        :rtype: str
        """
        return self._algo_name

    @algo_name.setter
    def algo_name(self, algo_name):
        """Sets the algo_name of this EventListener.


        :param algo_name: The algo_name of this EventListener.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and algo_name is None:  # noqa: E501
            raise ValueError("Invalid value for `algo_name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                algo_name is not None and len(algo_name) > 255):
            raise ValueError("Invalid value for `algo_name`, length must be less than or equal to `255`")  # noqa: E501

        self._algo_name = algo_name

    @property
    def algo_owner(self):
        """Gets the algo_owner of this EventListener.  # noqa: E501


        :return: The algo_owner of this EventListener.  # noqa: E501
        :rtype: str
        """
        return self._algo_owner

    @algo_owner.setter
    def algo_owner(self, algo_owner):
        """Sets the algo_owner of this EventListener.


        :param algo_owner: The algo_owner of this EventListener.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and algo_owner is None:  # noqa: E501
            raise ValueError("Invalid value for `algo_owner`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                algo_owner is not None and len(algo_owner) > 255):
            raise ValueError("Invalid value for `algo_owner`, length must be less than or equal to `255`")  # noqa: E501

        self._algo_owner = algo_owner

    @property
    def algo_version(self):
        """Gets the algo_version of this EventListener.  # noqa: E501


        :return: The algo_version of this EventListener.  # noqa: E501
        :rtype: str
        """
        return self._algo_version

    @algo_version.setter
    def algo_version(self, algo_version):
        """Sets the algo_version of this EventListener.


        :param algo_version: The algo_version of this EventListener.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and algo_version is None:  # noqa: E501
            raise ValueError("Invalid value for `algo_version`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                algo_version is not None and len(algo_version) > 255):
            raise ValueError("Invalid value for `algo_version`, length must be less than or equal to `255`")  # noqa: E501

        self._algo_version = algo_version

    @property
    def algo_timeout_seconds(self):
        """Gets the algo_timeout_seconds of this EventListener.  # noqa: E501


        :return: The algo_timeout_seconds of this EventListener.  # noqa: E501
        :rtype: int
        """
        return self._algo_timeout_seconds

    @algo_timeout_seconds.setter
    def algo_timeout_seconds(self, algo_timeout_seconds):
        """Sets the algo_timeout_seconds of this EventListener.


        :param algo_timeout_seconds: The algo_timeout_seconds of this EventListener.  # noqa: E501
        :type: int
        """

        self._algo_timeout_seconds = algo_timeout_seconds

    @property
    def listener_owner(self):
        """Gets the listener_owner of this EventListener.  # noqa: E501


        :return: The listener_owner of this EventListener.  # noqa: E501
        :rtype: str
        """
        return self._listener_owner

    @listener_owner.setter
    def listener_owner(self, listener_owner):
        """Sets the listener_owner of this EventListener.


        :param listener_owner: The listener_owner of this EventListener.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                listener_owner is not None and len(listener_owner) > 255):
            raise ValueError("Invalid value for `listener_owner`, length must be less than or equal to `255`")  # noqa: E501

        self._listener_owner = listener_owner

    @property
    def credentials(self):
        """Gets the credentials of this EventListener.  # noqa: E501


        :return: The credentials of this EventListener.  # noqa: E501
        :rtype: str
        """
        return self._credentials

    @credentials.setter
    def credentials(self, credentials):
        """Sets the credentials of this EventListener.


        :param credentials: The credentials of this EventListener.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and credentials is None:  # noqa: E501
            raise ValueError("Invalid value for `credentials`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                credentials is not None and len(credentials) > 255):
            raise ValueError("Invalid value for `credentials`, length must be less than or equal to `255`")  # noqa: E501

        self._credentials = credentials

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EventListener):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EventListener):
            return True

        return self.to_dict() != other.to_dict()
